<template lang="html">
  <butter-button theme="filter" size="ui">
    <butter-icon name="calendar" width="16" height="16" class="icon" />
    <span>Date Range: <a @click.prevent="$emit('update')" href="#">{{ formatDate(times.start) }} - {{ formatDate(times.end, !sameDay) }}</a></span>
    <div class="clear" @click="$emit('clear')">
      <butter-icon name="close" width="16" height="16" />
    </div>
  </butter-button>
</template>

<script>
const MONTHS = ['January', 'February', 'March', 'April', 'May', 'June', 'July', 'August', 'September', 'October', 'November', 'December']
export default {
  props: {
    times: {
      default() {
        return {}
      }
    },
    icon: {
      default: null,
      type: String
    }
  },
  methods: {
    formatDate(timestamp, showDay = true, twelveHour = true) {
      const day = showDay ? `${MONTHS[timestamp.getMonth()]} ${timestamp.getDate()}, ${timestamp.getFullYear()} ` : ''
      let hour = timestamp.getHours()
      let minutes = timestamp.getMinutes()
      let seconds = timestamp.getSeconds()
      const meridiem = hour < 12 ? ' AM' : ' PM'
      if (twelveHour && hour > 12) {
        hour -= 12
      }
      const time = `${hour}:${minutes < 10 && '0' || ''}${minutes}:${seconds < 10 && '0' || ''}${seconds}${twelveHour && meridiem}`
      return `${day}${time}`
    }
  },
  computed: {
    sameDay() {
      return this.times.start.getDate() === this.times.end.getDate()
    }
  }
}
</script>
